#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <errno.h>
#include "adder.h"

#define NIT 10000000

void fadder(struct adder *adder)
{
	adder->r = adder->a + adder->b;
}

int main(void)
{
	clock_t start;
	struct adder adder;
	double time;
	int i, fd;

	fd = open("/dev/adder", O_RDWR, 0);
	if (fd < 0) {
		fprintf(stderr, "Could not open adder\n");
		return -EINVAL;
	}

	start = clock();
	for (i = 0; i < NIT; ++i) {
		adder.a = i;
		adder.b = -i;
		ioctl(fd, 0, &adder);
		if (adder.r) {
			fprintf(stderr, "Seriously you say %d + %d is %d\n", adder.a, adder.b, adder.r);
			break;
		}
	}
	time = clock() - start;
	time = time / ((double)CLOCKS_PER_SEC);
	printf("%d ioctl tooks %f seconds %f micros per call\n", i, time, (time*1000.0) / ((double)i/1000.0));

	start = clock();
	for (i = 0; i < NIT; ++i) {
		adder.a = i;
		adder.b = -i;
		fadder(&adder);
		if (adder.r) {
			fprintf(stderr, "Seriously you say %d + %d is %d\n", adder.a, adder.b, adder.r);
			break;
		}
	}
	time = clock() - start;
	time = time / ((double)CLOCKS_PER_SEC);
	printf("%d func  tooks %f seconds %f micros per call\n", i, time, (time*1000.0) / ((double)i/1000.0));
}
